/* Other needed include files */

#include "windows.h"	    /* required for all Windows applications */
#include "winmem32.h"
#include "time.h"
#define NO_GUI		0
#define EXTERNC
#define WIN31
#include "..\commona.h"
#include "..\commonb.h"
#include "..\commonc.h"
#include "..\primenet.h"

/* Dialog box IDs */

#define IDM_ABOUT 	100
#define IDM_START 	101
#define IDM_CONTINUE 	102
#define IDM_TIME 	103
#define IDM_DEBUG 	104
#define IDM_COMPARE 	105
#define IDM_SPEED	107
#define IDM_RANGE	108
#define IDM_ERRCHK	109
#define IDM_AUTO	110
#define IDM_FACTOR	111
#define IDM_OUTPUT	113
#define IDM_RANGESTATUS	115
#define IDM_SELFTEST	116
#define IDM_PASSWORD	117
#define IDM_RANGEFACTOR	118
#define IDM_RANGEDBLCHK	119
#define IDM_TORTURETEST	120
#define IDM_EXIT 	199
#define ID_P		200
#define ID_ITER		201
#define ID_P1		202
#define ID_P2		203
#define ID_B1		204
#define ID_B2		205
#define ID_FF		206
#define IDC_CYRIX	207
#define IDC_486		208
#define IDC_PENTIUM	209
#define IDC_PRO		210
#define ID_P3		211

/* Window/Dialog management routines */

long GetProfileLong (char FAR *, char FAR *, long);
void WriteProfileLong (char FAR *, char FAR *, long);
int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
BOOL InitApplication(HANDLE);
BOOL InitInstance(HANDLE, int, HWND FAR *);
long FAR PASCAL MainWndProc(HWND, UINT, WORD, LONG);
BOOL FAR PASCAL About(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL Password(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL Start(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL Range(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL Time(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL Factor(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL Pref(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL Speed(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL AbortDlgProc(HWND, UINT, UINT, LONG);

/* Global variables */

extern HWND NEAR hMainWindow;
extern WORD NEAR DataSel;
extern WORD NEAR CodeSel;
extern DWORD NEAR p;
extern double NEAR maxerr;

/* Internal routines */

int FAR PASCAL loadfac ();
int FAR PASCAL loadRightExe (unsigned long, unsigned long FAR *);
void FAR PASCAL lucasSetup (unsigned long, unsigned long);
int FAR PASCAL load32 (LPSTR);
int FAR PASCAL reserveMem ();
void FAR PASCAL freeMem ();
void Sleep (unsigned long);

void lucas_relay ();
#define setupf		setup32
#define factor64	fac64

DWORD FAR PASCAL setup32 (void);
DWORD FAR PASCAL lucas32 (void);
WORD FAR PASCAL fac64 (void);

#define DATA_ADDR	0x00010000	// Addr of the input doubles

extern HWND NEAR hMainWnd;
extern HWND NEAR hDlgAbort;

extern HMODULE HLIB;			// Handle of networking DLL
extern int (CALLBACK *PRIMENET)(short, void *);

