;	Static Name Aliases
;
	TITLE   USE32
	.386
_TEXT	SEGMENT USE16 BYTE PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT USE16 WORD PUBLIC 'DATA'
EXTRN	_DATASEL:WORD
EXTRN	_CODESEL:WORD
EXTRN	_MAXERR:QWORD
EXTRN	_SUMOUT:QWORD
EXTRN	_SUMINP:QWORD
EXTRN	_ERRCHK:DWORD
EXTRN	_FACMSW:DWORD
EXTRN	_FACLSW:DWORD
EXTRN	_FACPASS:DWORD
EXTRN	_CPU_TYPE:WORD
OLDSS	DW	0
OLDSP	DW	0
ENTRY1	LABEL FWORD
ENTOFF1	DD	00000800h
ENTSEL1	DW	0
ENTRY2	LABEL FWORD
ENTOFF2	DD	00001800h
ENTSEL2	DW	0
STKOFF	EQU	0000FFFCh

_DATA	ENDS
CONST	SEGMENT USE16 WORD PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT USE16 WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP	CONST,	_BSS,	_DATA
	ASSUME  CS: _TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP
_TEXT      SEGMENT
	PUBLIC	SETUP32
SETUP32	PROC FAR
	push	esi			; Compiler expects these preserved
	push	edi
	mov	ax,_CODESEL
	mov	ecx,_FACLSW
	mov	ENTSEL1,ax
	mov	OLDSP,sp
	mov	OLDSS,ss
	push	ds
	pop	es
	mov	ax,_DATASEL
	mov	ds,ax
assume ds:nothing
	mov	fs,ax
	mov	gs,ax
	mov	ss,ax
assume ss:nothing
	mov	esp,STKOFF
	call	[ENTRY1]
	mov	bx,es
	mov	ds,bx
assume ds:dgroup
	mov	ss,OLDSS
assume ss:dgroup
	mov	sp,OLDSP
	pop	edi			; Compiler expects these preserved
	pop	esi
	ret
SETUP32	ENDP

	PUBLIC	LUCAS32
LUCAS32	PROC FAR
	push	esi			; Compiler expects these preserved
	push	edi
	mov	ax,_CODESEL
	mov	ecx,_ERRCHK
	mov	ENTSEL2,ax
	mov	OLDSP,sp
	mov	OLDSS,ss
	push	ds
	pop	es
	mov	ax,_DATASEL
	mov	ds,ax
assume ds:nothing
	mov	fs,ax
	mov	gs,ax
	mov	ss,ax
assume ss:nothing
	mov	esp,STKOFF
	call	[ENTRY2]
	mov	cx,es
	mov	ds,cx
assume ds:dgroup
	mov	ss,OLDSS
assume ss:dgroup
	mov	sp,OLDSP
	fstp	_MAXERR
	fstp	_SUMOUT
	fstp	_SUMINP
	pop	edi			; Compiler expects these preserved
	pop	esi
	ret
LUCAS32	ENDP

	PUBLIC	FAC64
FAC64 PROC FAR
	push	esi			; Compiler expects these preserved
	push	edi
	mov	ax,_CODESEL
	mov	ecx,_FACMSW
	mov	dx,_CPU_TYPE
	mov	esi,_FACPASS
	mov	ENTSEL2,ax
	mov	OLDSP,sp
	mov	OLDSS,ss
	push	ds
	pop	es
	mov	ax,_DATASEL
	mov	ds,ax
assume ds:nothing
	mov	fs,ax
	mov	gs,ax
	mov	ss,ax
assume ss:nothing
	mov	esp,STKOFF
	call	[ENTRY2]
	mov	cx,es
	mov	ds,cx
assume ds:dgroup
	mov	ss,OLDSS
assume ss:dgroup
	mov	_FACMSW,edi		; Factor MSW
	mov	_FACLSW,esi		; Factor LSW
	mov	sp,OLDSP
	pop	edi			; Compiler expects these preserved
	pop	esi
	ret
FAC64 ENDP

_TEXT	ENDS
END
